/*
  Blank Simple Project.c
  http://learn.parallax.com/propeller-c-tutorials 
*/
#undef DEBUG

#ifdef DEBUG
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#define print printf
#else
#include "simpletools.h"                      // Include simple tools
#include "fdserial.h"
#endif

struct nmea{

char gpsname[6];
char fix;


char latchar;
float lat[8];
float gpstime[6];
float longitude[9];
char longitudechar;
char RMC[80]; //gps string 
float speed[5];
float track[5];
float date[6];
float magvar[5];
char magdirection;
float checksum[5];
}gps;

char RMC[80]; //gps string 
char gpsraw;

void getdata2(); //receive data from gps

void print_data(); 
void init();

int index;
char rmc_test[6] = {"x"};

#ifdef DEBUG
#define fdserial_rxChar(x) getchar()
#else
int rx_pin = 26;
int tx_pin = 27;
int mode_ = 0;
int Baud_rate = 9600;

fdserial *GPS;  //MASK FOR THE FDSERIAL INPUT
#endif

int main()                                    // Main function
{
    init();
    while(1)
    {
        // getdata();
        getdata2();
        // print_data();
    } 
}        

void init()
{
#ifndef DEBUG
    GPS = fdserial_open(rx_pin,tx_pin,mode_ ,Baud_rate);
#endif
}

         

void getdata2()
{
    //read in characters from the GPS
    int idx = 0;
    do
    {
        gpsraw = fdserial_rxChar(GPS);
        RMC[idx++] = gpsraw;      
    } while(gpsraw != 13 && gpsraw != 10);
    RMC[idx] = 0;      //null terminate

    

    if(strncmp(RMC, "$GPRMC", 6) == 0)
        print_data();
    //if(strncmp(RMC, "GPGGA", 5) == 0)
        //print_data();
}
            
void print_data()            
{
#if 0
 //   for(int index = 0;  index <= 6; index++)
       // print("%c",RMC[index]);
#else
  
          
            strcpy(gps.gpsname,strtok(RMC, ","));
            
            strcpy(gps.gpstime,strtok(NULL, ","));
            
            strcpy( gps.fix,strtok(NULL, ","));
            
            strcpy( gps.lat,strtok(NULL, ","));
            
            strcpy( gps.latchar,strtok(NULL, ","));
            
            strcpy( gps.longitude,strtok(NULL, ","));
            
            strcpy( gps.longitudechar,strtok(NULL, ","));
            
            strcpy( gps.speed,strtok(NULL, ","));
            
            strcpy( gps.track,strtok(NULL, ","));
            
            strcpy( gps.date,strtok(NULL, ","));
            
            strcpy( gps.magvar,strtok(NULL, ","));
            
            strcpy( gps.magdirection,strtok(NULL, ","));
            
            strcpy( gps.checksum,strtok(NULL, ","));
           
    {
      
     
   print("gps sentance:   %s\n", gps.gpsname); //works
   
   print("zulu time:  %s\n", gps.gpstime); //works
   
   print("status:  %s\n", gps.fix); //works
   
   print("Lattitude: %s\n", gps.lat); //works
   
   print("Above or Below the equator: %c\n", gps.latchar); //works
     
   print("Longitude:  %s\n", gps.longitude); //works
     
   print("  %s\n", gps.longitudechar); //works
      
   print("Velocity:  %s\n", gps.speed); //works 
     
   print("Date:  %s\n", gps.track); //works 
     
   print("Date:  %s\n", gps.date); //works 
     
   print("Magnitic Variation:  %s\n", gps.magvar); //works 
     
   print("Checksum raw value: %s\n", gps.checksum); //works 
     
   print("\n\n");
  
      }   
#endif
}        

